diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 479bf0e34..6c6ebda32 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -5,15 +5,16 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 
 public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStandard<T> {
     public BlockModelFluid(Block<T> block) {
@@ -21,63 +22,66 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(worldSource, x, y, z, 0);
-        float r = (float)(color >> 16 & 0xff) / 255F;
-        float g = (float)(color >> 8 & 0xff) / 255F;
-        float b = (float)(color & 0xff) / 255F;
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
+        float r = (float) (color >> 16 & 0xff) / 255F;
+        float g = (float) (color >> 8 & 0xff) / 255F;
+        float b = (float) (color & 0xff) / 255F;
 
-        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
+        TilePos queryPos = new TilePos();
 
-        boolean renderTop = shouldSideBeRendered(worldSource, bounds, x, y + 1, z, Side.TOP);
-        boolean flag1 = shouldSideBeRendered(worldSource, bounds, x, y - 1, z, Side.BOTTOM);
+        final int x = tilePos.x();
+        final int y = tilePos.y();
+        final int z = tilePos.z();
+
+        AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
+
+        boolean renderTop = shouldSideBeRendered(worldSource, bounds, tilePos.up(queryPos), Side.TOP);
+        boolean flag1 = shouldSideBeRendered(worldSource, bounds, tilePos.down(queryPos), Side.BOTTOM);
         boolean[] aflag = new boolean[4];
-        aflag[0] = shouldSideBeRendered(worldSource, bounds, x, y, z - 1, Side.NORTH);
-        aflag[1] = shouldSideBeRendered(worldSource, bounds, x, y, z + 1, Side.SOUTH);
-        aflag[2] = shouldSideBeRendered(worldSource, bounds, x - 1, y, z, Side.WEST);
-        aflag[3] = shouldSideBeRendered(worldSource, bounds, x + 1, y, z, Side.EAST);
-        if(!renderTop && !flag1 && !aflag[0] && !aflag[1] && !aflag[2] && !aflag[3])
-        {
+        aflag[0] = shouldSideBeRendered(worldSource, bounds, tilePos.north(queryPos), Side.NORTH);
+        aflag[1] = shouldSideBeRendered(worldSource, bounds, tilePos.south(queryPos), Side.SOUTH);
+        aflag[2] = shouldSideBeRendered(worldSource, bounds, tilePos.west(queryPos), Side.WEST);
+        aflag[3] = shouldSideBeRendered(worldSource, bounds, tilePos.east(queryPos), Side.EAST);
+        if (!renderTop && !flag1 && !aflag[0] && !aflag[1] && !aflag[2] && !aflag[3]) {
             return false;
         }
         boolean didRender = false;
-        
+
         final float sideBottom = 0.5f;
         final float sideTop = 1.0f;
         final float sideNorthSouth = 0.8f;
         final float sideEastWest = 0.6f;
 
         final float yOff = 0.001f;
-        int meta = worldSource.getBlockMetadata(x, y, z);
-        float f7 = block.getLogic().getFluidHeight(worldSource, new TilePos(x, y, z));
-        float f8 = block.getLogic().getFluidHeight(worldSource, new TilePos(x, y, z + 1));
-        float f9 = block.getLogic().getFluidHeight(worldSource, new TilePos(x + 1, y, z + 1));
-        float f10 = block.getLogic().getFluidHeight(worldSource, new TilePos(x + 1, y, z));
-        if(renderBlocks.renderAllFaces || renderTop)
-        {
+        int meta = worldSource.getBlockData(tilePos);
+        float f7 = this.block.getLogic().getFluidHeight(worldSource, tilePos);
+        float f8 = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(0, 0, 1, queryPos));
+        float f9 = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(1, 0, 1, queryPos));
+        float f10 = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(1, 0, 0, queryPos));
+        if (renderBlocks.renderAllFaces || renderTop) {
             didRender = true;
             IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.TOP, meta);
-            float rotation = (float) this.block.getLogic().getSlopeAngle(worldSource, new TilePos(x, y, z));
-            if(rotation > -999F)
-            {
+            float rotation = (float) this.block.getLogic().getSlopeAngle(worldSource, tilePos);
+            if (rotation > -999F) {
                 texture = getBlockTextureFromSideAndMetadata(Side.NORTH, meta);
             } else {
                 rotation = 0.0F;
             }
             float blockBrightness = 1.0f;
-            if(LightmapHelper.isLightmapEnabled()) {
-            	int light = block.getLightmapCoord(worldSource, x, y, z);
-            	int lightUp = block.getLightmapCoord(worldSource, x, y + 1, z);
-            	
-            	tessellator.setLightmapCoord(LightmapHelper.max(light, lightUp));
-            }else {
-            	blockBrightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+            if (LightmapHelper.isLightmapEnabled()) {
+                int light = this.block.getLightmapCoord(worldSource, tilePos);
+                int lightUp = this.block.getLightmapCoord(worldSource, tilePos.up(queryPos));
+
+                tessellator.setLightmapCoord(LightmapHelper.max(light, lightUp));
+            } else {
+                blockBrightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
             }
-            if (texture.namespaceId.toString().contains("_flowing")){
+            if (texture.namespaceId.toString().contains("_flowing")) {
                 double centerU = texture.getSubIconU(0.5);
                 double centerV = texture.getSubIconV(0.5);
-                float cSin = MathHelper.cos(rotation)/2;
-                float sin = MathHelper.sin(rotation)/2;
+                float cSin = MathHelper.cos(rotation) / 2;
+                float sin = MathHelper.sin(rotation) / 2;
 
                 double minU = texture.getIconUMin();
                 double maxU = texture.getIconUMax();
@@ -85,62 +89,48 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 double maxV = texture.getIconVMax();
 
                 tessellator.setColorOpaque_F(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
-                tessellator.addVertexWithUV(x,      (float)y + f7,      z,      ((minU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (minU - centerU) * cSin) + centerV);
-                tessellator.addVertexWithUV(x,      (float)y + f8,      z + 1,  ((maxU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
-                tessellator.addVertexWithUV(x + 1,  (float)y + f9,      z + 1,  ((maxU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
-                tessellator.addVertexWithUV(x + 1,  (float)y + f10,     z,      ((minU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (minU - centerU) * cSin) + centerV);
+                tessellator.addVertexWithUV(x, (float) y + f7, z, ((minU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (minU - centerU) * cSin) + centerV);
+                tessellator.addVertexWithUV(x, (float) y + f8, z + 1, ((maxU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
+                tessellator.addVertexWithUV(x + 1, (float) y + f9, z + 1, ((maxU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
+                tessellator.addVertexWithUV(x + 1, (float) y + f10, z, ((minU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (minU - centerU) * cSin) + centerV);
             } else {
                 tessellator.setColorOpaque_F(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
-                tessellator.addVertexWithUV(x,      (float)y + f7,      z,      texture.getIconUMin(), texture.getIconVMax());
-                tessellator.addVertexWithUV(x,      (float)y + f8,      z + 1,  texture.getIconUMax(), texture.getIconVMax());
-                tessellator.addVertexWithUV(x + 1,  (float)y + f9,      z + 1,  texture.getIconUMax(), texture.getIconVMin());
-                tessellator.addVertexWithUV(x + 1,  (float)y + f10,     z,      texture.getIconUMin(), texture.getIconVMin());
+                tessellator.addVertexWithUV(x, (float) y + f7, z, texture.getIconUMin(), texture.getIconVMax());
+                tessellator.addVertexWithUV(x, (float) y + f8, z + 1, texture.getIconUMax(), texture.getIconVMax());
+                tessellator.addVertexWithUV(x + 1, (float) y + f9, z + 1, texture.getIconUMax(), texture.getIconVMin());
+                tessellator.addVertexWithUV(x + 1, (float) y + f10, z, texture.getIconUMin(), texture.getIconVMin());
             }
 
         }
-        if(renderBlocks.renderAllFaces || flag1)
-        {
+        if (renderBlocks.renderAllFaces || flag1) {
             float brightness = 1.0f;
-            if(LightmapHelper.isLightmapEnabled()) {
-            	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y - 1, z));
-            }else {
-            	brightness = renderBlocks.getBlockBrightness(worldSource, x, y - 1, z);
+            if (LightmapHelper.isLightmapEnabled()) {
+                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos.down(queryPos)));
+            } else {
+                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos.down(queryPos));
             }
             tessellator.setColorOpaque_F(sideBottom * brightness * r, sideBottom * brightness * g, sideBottom * brightness * b);
 
-            renderBlocks.renderBottomFace(tessellator, bounds,x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
+            renderBlocks.renderBottomFace(tessellator, bounds, x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
             didRender = true;
         }
-        for(int side = 0; side < 4; side++)
-        {
-            int xB = x;
-            int yB = y;
-            int zB = z;
-            if(side == 0)
-            {
-                zB--;
-            }
-            if(side == 1)
-            {
-                zB++;
-            }
-            if(side == 2)
-            {
-                xB--;
-            }
-            if(side == 3)
-            {
-                xB++;
+        TilePos posB = new TilePos(0, 0, 0);
+        for (int side = 0; side < 4; side++) {
+            posB.set(x, y, z);
+            switch (side) {
+                case 0 -> posB.set(x, y, z - 1); // North
+                case 1 -> posB.set(x, y, z + 1); // South
+                case 2 -> posB.set(x - 1, y, z); // West
+                case 3 -> posB.set(x + 1, y, z); // East
             }
             float uOff;
-            if (side == 0 || side == 1){
+            if (side == 0 || side == 1) {
                 uOff = (x & 1) == 0 ? 0.0f : 0.5f;
             } else {
                 uOff = (z & 1) == 0 ? 0.0f : 0.5f;
             }
             IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.getSideById(side + 2), meta);
-            if(!renderBlocks.renderAllFaces && !aflag[side])
-            {
+            if (!renderBlocks.renderAllFaces && !aflag[side]) {
                 continue;
             }
             float f13;
@@ -149,34 +139,28 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             float f19;
             float f20;
             float f21;
-            if(side == 0)
-            {
+            if (side == 0) {
                 f13 = f7;
                 f15 = f10;
                 f17 = x + 0.0001f;
                 f20 = x + 1 - 0.0001f;
                 f19 = z + 0.0001f;
                 f21 = z + 0.0001f;
-            } else
-            if(side == 1)
-            {
+            } else if (side == 1) {
                 f13 = f9;
                 f15 = f8;
                 f17 = x + 1 - 0.0001f;
                 f20 = x + 0.0001f;
                 f19 = z + 1 - 0.0001f;
                 f21 = z + 1 - 0.001f;
-            } else
-            if(side == 2)
-            {
+            } else if (side == 2) {
                 f13 = f8;
                 f15 = f7;
                 f17 = x + 0.0001f;
                 f20 = x + 0.0001f;
                 f19 = z + 1 - 0.0001f;
                 f21 = z + 0.0001f;
-            } else
-            {
+            } else {
                 f13 = f10;
                 f15 = f9;
                 f17 = x + 1 - 0.0001f;
@@ -188,23 +172,23 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             float vOff = (y & 1) == 0 ? 0.0F : 0.5f;
             double d4 = texture.getSubIconU(0.0F + uOff);
             double d5 = texture.getSubIconU(0.5F + uOff);
-            double d6 = texture.getSubIconV(0.5F - f13/2 + vOff);
-            double d7 = texture.getSubIconV(0.5F - f15/2 + vOff);
+            double d6 = texture.getSubIconV(0.5F - f13 / 2 + vOff);
+            double d7 = texture.getSubIconV(0.5F - f15 / 2 + vOff);
             double d8 = texture.getSubIconV(0.5F + vOff);
-			float brightness = 1.0f;
-			if(LightmapHelper.isLightmapEnabled()) {
-				tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, xB, yB, zB));
-			}else {
-				brightness = renderBlocks.getBlockBrightness(worldSource, xB, yB, zB);
-			}
-			if(side < 2) {
-				brightness *= sideNorthSouth;
-			}else {
-				brightness *= sideEastWest;
-			}
+            float brightness = 1.0f;
+            if (LightmapHelper.isLightmapEnabled()) {
+                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, posB));
+            } else {
+                brightness = renderBlocks.getBlockBrightness(worldSource, posB);
+            }
+            if (side < 2) {
+                brightness *= sideNorthSouth;
+            } else {
+                brightness *= sideEastWest;
+            }
             tessellator.setColorOpaque_F(sideTop * brightness * r, sideTop * brightness * g, sideTop * brightness * b);
-            tessellator.addVertexWithUV(f17, (float)y + f13, f19, d4, d6);
-            tessellator.addVertexWithUV(f20, (float)y + f15, f21, d5, d7);
+            tessellator.addVertexWithUV(f17, (float) y + f13, f19, d4, d6);
+            tessellator.addVertexWithUV(f20, (float) y + f15, f21, d5, d7);
             tessellator.addVertexWithUV(f20, y, f21, d5, d8);
             tessellator.addVertexWithUV(f17, y, f19, d4, d8);
         }
@@ -217,24 +201,18 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, @NotNull Side side)
-    {
-        Material material = blockAccess.getBlockMaterial(x, y, z);
-        if(material == block.getMaterial())
-        {
+    public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
+        Material material = source.getBlockMaterial(tilePos);
+        if (material == this.block.getMaterial()) {
             return false;
         }
-        if(material == Material.ice)
-        {
+        if (material == Materials.ICE) {
             return true;
         }
-        if(side == Side.TOP)
-        {
+        if (side == Side.TOP) {
             return true;
-        }
-        else
-        {
-            return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
+        } else {
+            return super.shouldSideBeRendered(source, bounds, tilePos, side);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index 0db8d6a2a..c7dc78262 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -8,6 +8,7 @@ import net.minecraft.core.block.BlockLogicFullyRotatable;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -17,8 +18,8 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        final int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        final int meta = worldSource.getBlockData(tilePos);
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(meta);
 
         switch (dir) {
@@ -55,7 +56,7 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
                 renderBlocks.uvRotateBottom = 2;
                 break;
         }
-        final boolean result = renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        final boolean result = renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos);
         renderBlocks.resetRenderBlocks();
 
         return result;
@@ -68,11 +69,11 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(data);
         if (side == dir.getSide()) {
-            return blockTextures.get(Side.TOP);
+            return this.blockTextures.get(Side.TOP);
         }
-        return side.getDirection() != dir.getOpposite() ? blockTextures.get(Side.NORTH) : blockTextures.get(Side.BOTTOM);
+        return side.getDirection() != dir.getOpposite() ? this.blockTextures.get(Side.NORTH) : this.blockTextures.get(Side.BOTTOM);
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
index 64a4a8a16..53d351639 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFurnace.java
@@ -8,6 +8,8 @@ import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFurnace<T extends BlockLogic>
@@ -18,13 +20,13 @@ public class BlockModelFurnace<T extends BlockLogic>
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side) {
-        int data = blockAccess.getBlockMetadata(x, y, z);
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource blockAccess, @NotNull TilePosc tilePos, @NotNull Side side) {
+        int data = blockAccess.getBlockData(tilePos);
         int index = Sides.orientationLookUpHorizontal[6 * Math.min(data, 5) + side.getId()];
-        if (index >= Sides.orientationLookUpHorizontal.length) return blockTextures.get(Side.BOTTOM);
+        if (index >= Sides.orientationLookUpHorizontal.length) return this.blockTextures.get(Side.BOTTOM);
         if (index == Side.NORTH.getId()) {
-            IconCoordinate originalFront = blockTextures.get(Side.NORTH);
-            Container container = (Container) blockAccess.getTileEntity(x, y, z);
+            IconCoordinate originalFront = this.blockTextures.get(Side.NORTH);
+            Container container = (Container) blockAccess.getTileEntity(tilePos);
             if (container != null) {
                 boolean hasOutput = container.getItem(2) != null;
                 if (hasOutput) {
@@ -33,6 +35,6 @@ public class BlockModelFurnace<T extends BlockLogic>
             }
             return originalFront;
         }
-        return blockTextures.get(Side.getSideById(index));
+        return this.blockTextures.get(Side.getSideById(index));
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
index 3fbcede22..23dbdad33 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
@@ -7,13 +7,14 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.data.block.BlockModelData;
 import org.useless.dragonfly.models.block.StaticBlockModel;
 
-public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T>{
+public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     private final StaticBlockModel staticModel;
 
     public BlockModelGeneric(@NotNull final Block<T> block, @NotNull final StaticBlockModel staticModel) {
@@ -27,37 +28,40 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T>{
     }
 
     @Override
-    public boolean renderNoCulling(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, final int x, final int y, final int z) {
+    public boolean renderNoCulling(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return this.staticModel.renderAttached(this,
             tessellator,
-            worldSource, x,
-            y,
-            z,
+            worldSource,
+            tilePos.x(),
+            tilePos.y(),
+            tilePos.z(),
             0, 0, 0, false, null);
     }
 
     @Override
-    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, final int x, final int y, final int z) {
+    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return this.staticModel.renderAttached(this,
             tessellator,
-            worldSource, x,
-            y,
-            z,
+            worldSource,
+            tilePos.x(),
+            tilePos.y(),
+            tilePos.z(),
             0, 0, 0, true, null);
     }
 
     @Override
-    public boolean renderOverbright(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, final int x, final int y, final int z) {
+    public boolean renderOverbright(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         throw new UnsupportedOperationException();
     }
 
     @Override
-    public boolean renderWithOverrideTexture(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, final int x, final int y, final int z, final IconCoordinate textureIndex) {
+    public boolean renderWithOverrideTexture(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos, final IconCoordinate textureIndex) {
         return this.staticModel.renderAttached(this,
             tessellator,
-            worldSource, x,
-            y,
-            z,
+            worldSource,
+            tilePos.x(),
+            tilePos.y(),
+            tilePos.z(),
             0, 0, 0, true, textureIndex);
     }
 
@@ -96,7 +100,7 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T>{
     }
 
     @Override
-    public int particleColorIndex(@NotNull final WorldSource worldSource, final int x, final int y, final int z, @NotNull final Side side, final int meta) {
+    public int particleColorIndex(@NotNull final WorldSource worldSource, final @NotNull TilePosc tilePos, @NotNull final Side side, final int meta) {
         return this.staticModel.particleColorIndex(side);
     }
 }
